import urllib
from string import upper, split, find
import cgi
import cgitb; cgitb.enable()
import time
import os
from os.path import join
import md5

class QueryResponder(object):
    def __init__ (self, appurl):
        """Utility class for communication between web server and application server. It is not a plugin
        """
        self.__appurl=appurl
    def getServiceMap(self):
        url = self.__appurl+"/serviceMap"
        dataHandle = urllib.urlopen(url)
        result = dataHandle.read()
        if find(result, 'internal error') != -1:
            print result
        return result
        
    def getTags(self,det,servicename,schemaname,viacache):
        url = self.__appurl+"/iov/getTags?"
        par = "det="+det+"&service="+servicename+"&schema="+schemaname+"&viacache="+viacache
        #print url+par
        dataHandle = urllib.urlopen(url+par)
        result = dataHandle.read()
        if find(result, 'internal error') != -1:
            print result
        return result.split(';')
        
    def getIOVForTag(self,det,servicename,schemaname,viacache,tag):
        url = self.__appurl+"/iov/getIOVForTag?"
        par = "det="+det+"&service="+servicename+"&schema="+schemaname+"&tag="+tag+"&viacache="+viacache
        dataHandle = urllib.urlopen(url+par)
        result = dataHandle.read();
        if find(result, 'internal error') != -1:
            print result
        return result
    
    def cleanTempsave(self):
        path = join(self.conf_dict['base_path'], "tempsave")
        now = time.time()
        for f in os.listdir(path):
            f = os.path.join(path, f)
            if os.stat(f).st_mtime < now - 20 *60:
                if os.path.isfile(f):
                    os.remove(f)
                    
    def exportIOV(self,det,service,schema,containername,inputTag,destTag,firstSince,lastTill,viacache):
        url = self.__appurl+'/iov/exportIOV?'
        #print 'fn',fn
        #print 'tag',tag
        #print 'service',service
        #print 'schema',schema
        #print 'viacache',viacache
        #print 'payload',payload
        par = "det="+det+"&service="+service+"&schema="+schema+"&containername="+containername+"&inputTag="+inputTag+"&destTag="+destTag+"&firstSince="+firstSince+"&lastTill="+lastTill+"&viacache="+viacache        
        print 'par ',par
        (filename,headers)=urllib.urlretrieve(url+par)
        print 'filename',filename
        print 'headers',headers
        return filename
    
    def getSqliteFile(self, det, file_name):
        self.cleanTempsave()
        if not self.conf_dict['CONF_DEDICATED_SERVER_URL']:
            sendErrorInformation('Configuration variable CONF_DEDICATED_SERVER_URL is not set <brCheck file configuration.xml')
        url = self.conf_dict['CONF_DEDICATED_SERVER_URL']+"/tag/getSqliteFile?"
        par = "dir="+det+"&file_name="+file_name
        dataHandle = urllib.urlopen(url+par)
        ts = int(time.time())
        filename = ts.__str__()+'_'+file_name
        temp_path = join(self.conf_dict['base_path'], "tempsave/"+filename)
        f = open(temp_path, 'wb')
        while 1:
            data = dataHandle.read(1024 * 8) # Read blocks of 8KB at a time
            if not data: break
            f.write(data)
        f.close()
     
     #   if len(result) > 1000:
     #       if (find(result, 'internal error') or find(result, 'Cmd-line error')):
     #           print "error"+result
            #sendErrorInformation('CondWeb returned internal error. <br>    Check if the server is UP and properly configured.<br>Received error:'+result)    
        return temp_path
    
    def informAboutFile(self, filename, port, detector):
        self.cleanTempsave()
        if not self.conf_dict['CONF_DEDICATED_SERVER_URL']:
            sendErrorInformation('Configuration variable CONF_DEDICATED_SERVER_URL is not set <brCheck file configuration.xml')
        url = self.conf_dict['CONF_DEDICATED_SERVER_URL']+"/tag/getFileInfo?"
        par = "file_name="+filename+"&port="+port+"&dir="+detector+"&pswd=adminminda"
        dataHandle = urllib.urlopen(url+par)
        result = dataHandle.read();
        return result

    
    def getConfigData(self, dataType, service = None):
        con = self.connectToDB()
        curs = con.cursor()
        if (dataType == 'detector'):
            rs = con.cursor().callproc("cms_condweb_config.cms_condweb_get_detector", [ curs])                    
        elif (dataType == 'production'):
            rs = con.cursor().callproc("cms_condweb_config.cms_condweb_get_production", [curs])
        elif (dataType == 'service'):
            rs = con.cursor().callproc("cms_condweb_config.cms_condweb_get_service", [curs])                    
        elif (dataType == 'pass'):
            passwd = curs.var(cx_Oracle.STRING)
            curs.callproc("cms_condweb_config.cms_condweb_get_password", [passwd, service])
            return passwd.getvalue();                
        data = rs[0].fetchall()
        res = []
        for row in data:
            res.append(row[0])
        
        return res
        
    
    def connectToDB(self):
        if not self.conf_dict['CONF_DB_TECHNOLOGY']:
            sendErrorInformation('Configuration variable CONF_DB_TECHNOLOGY is not set <br>Check file configuration.xml')



### TODO: jakis ladny throw...
#        if not (self.conf_dict['CONF_DB_TECHNOLOGY']== 'oracle')
#            'DB technology is set to'.self.conf_dict['CONF_DB_TECHNOLOGY'].
#            '<BR> This technology is not supported.'.
#            "<BR> Application's support was contacted.
#            <BR> Sorry for the inconvinience.";
#            sendErrorInformation('Configuration variable CONF_DB_TECHNOLOGY is  
#            set to an unknown technology<br>
#            Check file configuration.xml. Make sure parameter value is proper and the technology 
#            is supported by ADODB');    
#        }
#        //$DB->debug = true;
        if  not self.conf_dict['CONF_DB_HOST']:
            sendErrorInformation('Configuration variable CONF_DB_HOST is not set <br>Check file configuration.xml')        
        if not self.conf_dict['CONF_DB_PORT']:
            sendErrorInformation('Configuration variable CONF_DB_PORT is not set <br>Check file configuration.xml')
        
        if not self.conf_dict['CONF_DB_SID']:
            sendErrorInformation('Configuration variables CONF_DB_SID and CONF_DB_SERV_NAME are not set <br>Check file configuration.xml')    
        if not self.conf_dict['CONF_DB_USER']:
            sendErrorInformation('Configuration variable CONF_DB_USER is not set <br>Check file configuration.xml')        
        if not self.conf_dict['CONF_DB_SID']:
            sendErrorInformation('Configuration variable CONF_DB_PASS is not set <br>Check file configuration.xml')
        cstr =  self.conf_dict['CONF_DB_USER']+'/'+self.conf_dict['CONF_DB_PASS']+'@'+self.conf_dict['CONF_DB_HOST']+':'+self.conf_dict['CONF_DB_PORT']+'/'+self.conf_dict['CONF_DB_SID']     
        connection = cx_Oracle.Connection(cstr)
        return connection

    def insertRequest(self, det_name, prod_name, serv_name, obj_name, cmssw_ver, \
                      isO2O, hasmap, req_email, sqlite_test, devdb_test, \
                      other_test, upload_writer_file, upload_o2o, upload_XML):
        con = self.connectToDB()
        con.begin()
        try:
            writer_file_name = upload_writer_file.filename
            writer_file = upload_writer_file.file.read()
        except:
            writer_file_name = None
            writer_file = None 
            
        try:
            o2o_file_name = upload_o2o.filename
            o2o_file = upload_o2o.file.read()
        except:
            o2o_file_name = None
            o2o_file = None 
        
        try:
            custom_file_name = upload_XML.filename
            custom_file = upload_XML.file.read()
        except:
            custom_file_name = None
            custom_file = None     
        cond_id = -1        
        try:
            curs = con.cursor()
            curs.callproc('cms_condweb_insert_object', [cond_id, obj_name, cmssw_ver, \
                                                            writer_file, o2o_file, custom_file, \
                                                            det_name, prod_name, serv_name, isO2O, \
                                                            hasmap, req_email, devdb_test, sqlite_test, \
                                                            other_test, writer_file_name, o2o_file_name, \
                                                            custom_file_name])
            con.commit()
        except IntegrityError: 
           con.rollback()
           return('Object with the same name and CMSSW version already exists')  
        except:
            con.rollback()
            return Error    

   
    def getData(self, queryName, attributes, returns_cursor, out_params):
        con = self.connectToDB()
        ret_curs = con.cursor()
        par_val=[]
        if attributes != None:
            par_val = attributes.values()
            if returns_cursor=='true': 
                par_val.insert(0, ret_curs)
            else:
                spl = split(out_params, '|') 
                i=0
                for el in spl: 
                    if (el.find('file') > -1) and (el.find('file_name') == -1):
                        el = con.cursor().var(cx_Oracle.CLOB)
                        par_val.insert(i, el)
                        i+=1
                        continue
                    if (el.find('date') > -1):
                        el = con.cursor().var(cx_Oracle.DATETIME)
                    par_val.insert(i, el)
                    i+=1  
        else:
            par_val.insert(0, ret_curs)
        rs = con.cursor().callproc('cms_condweb_bookeeping.'+queryName, par_val)
        if returns_cursor=='true':
            return rs[0].fetchall();
        else:
            return rs

#DeclarePlugin ("/CondDB/QueryResponder", QueryResponder, {"baseUrl": "/CondDB/QueryResponder"})
