from Common import config
class DetConfig(object):
    def __init__(self,configfilepath):
        """Parse detector configuration file
        """
        self.__config=config.Config()
        self.__config.from_ini(configfilepath)
        
    def dict_name(self,detname):
        """get dict_name attribute from ini file for given det
        """
        dectproperty=None
        try:
            dectproperty=getattr(self.__config,detname)
        except AttributeError:
            print 'No configuration found for',detname
            return ''
        try:
            return getattr(dectproperty,'dict_name')
        except AttributeError:
            print 'dict_name is not configured for',detname
            return ''
        
    def services(self,detname):
        """get services attribute as list from ini file for given det
        """
        dectproperty=None
        try:
            dectproperty=getattr(self.__config,detname)
        except AttributeError:
            print 'No configuration found for',detname
            return []
        try:
            servicestr=getattr(dectproperty,'services')
            servicestr_clean=''.join(servicestr.strip(' ').split(' '))
            return servicestr_clean.split(',')
        except AttributeError:
            print 'services is not configured for',detname
            return []

    def serviceToServlet(self,detname,servicename):
        """translate service name to frontier servlet name according to translation rules in config file
        """
        dectproperty=None
        try:
            dectproperty=getattr(self.__config,detname)
        except AttributeError:
            print 'No configuration found for',detname
            return ''
        try:
            servletname=getattr(dectproperty,servicename)
            return servletname.strip(' ')
        except AttributeError:
            print 'servletname is not configured for',servicename
            return ''
        
if __name__ == "__main__":
    d=DetConfig('detector.conf')
    print 'dict name ',d.dict_name('STRIP')
    print 'services ',d.services('STRIP')
    print 'servlet for service cms_orcoff_prep',d.serviceToServlet('STRIP','cms_orcoff_prep')
